   title   DD_Basic - Siekmanski 2006
     .686p 
      .model flat, C, stdcall 
       option casemap :none 
      .xmm 

   include windows.inc
   include kernel32.inc
   include user32.inc
   include ole32.inc
   include oleaut32.inc
   include winmm.inc
   include gdi32.inc

   include include\dxmacros.inc
   include include\ddraw.inc
   include include\DD_util.inc
   include include\msvcrt.inc

   includelib kernel32.lib
   includelib user32.lib
   includelib ole32.lib
   includelib oleaut32.lib
   includelib winmm.lib
   includelib gdi32.lib
  
   includelib lib\ddraw.lib
   includelib lib\msvcrt.lib

.const

szClassName   db "Direct2D SinusScroller",0
szAppName     db "SinusScroller",0
szDXInfo      db "DDRAW info",0

SMILEY_ICON    equ 200
SinusFont      equ 504

.data

   align 4
scroll_breedte  dd      0
scroll_teller   dd      0
scroll_snelheid dd      31
scroll_snelcopy dd      1
scroll_pauze    equ     60*1	
font_breedte	equ     32
font_hoogte     equ     32

scroll_sneltab  dd       0,0
                dd      31,1
                dd      15,2
                dd       7,4
                dd       3,8
                dd       1,16

scrolly         dd      scroll_string
scroll_string   db      2,"   SIEKMANSKI   ",6,6,6,4,"  PRESENTS:   ",6,6,2,"A SINUS-SCROLLER ................  "
                db		5,"  PICTURE THIS: ",6,6,2," YOUR PIX32TRISTAR FONT IN MY SCROLLY ROUTINE.        "
                db      "JUST COMPARE THE FONT-PICTURE I REARRANGED FOR YOU         "
                db      3,"THIS IS THE ONLY WAY TO USE MY ROUTINE OR YOU HAVE TO REWRITE THE 'SINUS_SCROLLER' ROUTINE"
                db		" AND MAKE A LOOKUP TABLE WITH THE OFFSETS TO YOUR CHARACTER ORDERS.                "
                db		5,"    GREETZ      ",6,6,6
                db		5,"   SIEKMANSKI   ",6,6,6
                db		5,"                ",6,6,6
                db      0

   align 4

g_pDD          LPDIRECTDRAW7 NULL
g_pDDSPrimary  LPDIRECTDRAWSURFACE7 NULL
g_pDDSBack     LPDIRECTDRAWSURFACE7 NULL
g_pDDClipper   LPDIRECTDRAWCLIPPER NULL     

g_pDDSScrollScherm  LPDIRECTDRAWSURFACE7 NULL

bProg_actief   dd TRUE

dwWindow_Width  dd 512 ; our values
dwWindow_Height dd 384
dwWindow_Bits   dd 16

bMinimized    dd FALSE
bMaximized    dd FALSE

	align 4


.data?
   align 4

hInst        dd ?
hWnd         dd ? 
WndProc_ptr  dd ?
WndProcF_ptr dd ?
Heap         dd ?

WindowRect   RECT <?>
rcPrimary    RECT <?>
rcBack       RECT <?>
rcPicture    RECT <?>
ddBack_bltfx DDBLTFX <?>
colorkey	 DDCOLORKEY <?>
ddsd         DDSURFACEDESC2 <?>
ddscaps      DDSCAPS2 <?>

g_pSinusFont  DD_PICTURE <?>

sinuslengte	  equ 512
Sinus_Tabel	  dd  sinuslengte dup (?)
Sinus_Speed   dd  ?
Sinus_Waves   dd  ?

dwRGBBitCount      dd ?    ; actual screenbits
dwRBitMask         dd ?
dwGBitMask         dd ?
dwBBitMask         dd ?
dwScreenWidth      dd ?    ; window changes
dwScreenHeight     dd ?

ScreenWidth        dd ?    ; Auto init actual values
ScreenHeight       dd ?
ScreenBits         dd ?
ScreenRefreshRate  dd ?

.code

   include	common\DD_util.asm

Maak_SinusTabel proc uses edi lengte:dword,range:dword,sintab:dword
local teller,centrum:dword

	mov		eax,range
	shr		eax,1
	mov		centrum,eax

	fild	range
	fmul	FLOAT_(0.5)
	fstp	range

	fild	centrum
	mov		eax,centrum
	test	eax,eax
	jnz		is_even
	fsub	FLOAT_(0.5)
is_even:
	fstp	centrum

	mov		teller,0
	mov		eax,sintab
	mov		ecx,lengte
sinus_loop:
	fild	teller
	fidiv   lengte	
	fmul	FLOAT_(6.283185307179586232) ; 2 * PI
	fsin
	fmul	range
	fadd	centrum
	fistp	dword ptr [eax]
	inc 	teller
	add		eax,4
	dec     ecx
	jnz		sinus_loop
	ret
Maak_SinusTabel endp


Sinus_scroller proc
	LOCAL rcScrollScherm:RECT
	LOCAL rcScrollFont:RECT
	LOCAL X,Y,SinusTeller:DWORD

	mov		Sinus_Waves,1
	add		Sinus_Speed,2

plot_karakter:
    dec     scroll_teller
    jns     s_einde
    mov     eax,scroll_snelheid
    mov     scroll_teller,eax
    mov     ecx,scrolly
    inc     scrolly
    movzx   eax,byte ptr [ecx]
    cmp     eax,32
    jb      s_commando
    sub     eax,32
    
    shl		eax,5
	mov 	ecx,eax
	and		ecx,0ffh
	and		eax,0ff00h
	shr		eax,3

	mov 	rcScrollFont.left,ecx
	mov 	rcScrollFont.top,eax
	add		ecx,font_breedte
	add		eax,font_hoogte
	mov 	rcScrollFont.right,ecx
	mov 	rcScrollFont.bottom,eax
	
	coinvoke g_pDDSScrollScherm,IDirectDrawSurface7,BltFast,dwWindow_Width,0,g_pSinusFont.dwSurface,addr rcScrollFont,DDBLTFAST_WAIT

s_einde:
	mov		eax,scroll_snelcopy
	mov 	rcScrollScherm.left,eax
	mov 	rcScrollScherm.top,0
	add		eax,dwWindow_Width
	add		eax,font_breedte
	sub		eax,scroll_snelcopy
	mov 	rcScrollScherm.right,eax
	mov 	rcScrollScherm.bottom,font_hoogte
	
	coinvoke g_pDDSScrollScherm,IDirectDrawSurface7,BltFast,0,0,g_pDDSScrollScherm,addr rcScrollScherm,DDBLTFAST_WAIT
s_sinus:
	mov		X,0
	mov		Y,0
	mov 	rcScrollScherm.left,0
	mov 	rcScrollScherm.top,0
	mov 	rcScrollScherm.right,1
	mov 	rcScrollScherm.bottom,font_hoogte
	
	mov		SinusTeller,512
doe_sinus:
	mov		Y,64
	mov		eax,Sinus_Waves
	sub		Sinus_Speed,eax
	and		Sinus_Speed,sinuslengte-1
	mov		eax,Sinus_Speed
	lea		ecx,[Sinus_Tabel+eax*4]
	mov		eax,[ecx]
	add		Y,eax
	coinvoke g_pDDSBack,IDirectDrawSurface7,BltFast,X,Y,g_pDDSScrollScherm,addr rcScrollScherm,DDBLTFAST_WAIT or DDBLTFAST_SRCCOLORKEY
	inc		X
	add 	rcScrollScherm.left,1
	add 	rcScrollScherm.right,1
	dec		SinusTeller
	jnz		doe_sinus
	ret
 
s_commando:
	test	eax,eax
    jnz     s_speed
    lea     eax,scroll_string
    mov     scrolly,eax
    mov     [scroll_teller],0
    jmp     plot_karakter
s_speed:
    cmp     eax,5
    ja      s_pauze
    lea     eax,[scroll_sneltab+eax*8]
    mov     ecx,[eax]
    mov     scroll_snelheid,ecx
    mov     ecx,[eax+4]
    mov     scroll_snelcopy,ecx
    mov     scroll_teller,0
    jmp     plot_karakter
s_pauze:
    cmp     eax,6
    ja      s_special
    mov     scroll_teller,scroll_pauze
    mov     scroll_snelcopy,0
    jmp     plot_karakter
s_special:
;	create here more effects like changing Sinus_Waves and Sinus_Speed etc.............

    ret
Sinus_scroller endp


Load_AllPictures proc

   invoke   Load_Picture,SinusFont,addr g_pSinusFont
   mov		eax,dwWindow_Width
   add		eax,32
   invoke	Create_Surface,eax,32,addr g_pDDSScrollScherm

   mov      ddBack_bltfx.dwFillColor,RGB(0,0,64)
   coinvoke g_pDDSScrollScherm,IDirectDrawSurface7,Blt,NULL,NULL,NULL,DDBLT_COLORFILL or DDBLT_WAIT,addr ddBack_bltfx

   ;invoke	Set_TransparantColor,g_pDDSScrollScherm,RGB(255,0,255)
   invoke	Set_TransparantColor,g_pDDSScrollScherm,RGB(0,255,0)

	invoke	Maak_SinusTabel,sinuslengte,128,addr Sinus_Tabel
	mov		Sinus_Speed,0
	mov		Sinus_Waves,1

   ret
Load_AllPictures endp

StartDD proc
   invoke  DirectDrawCreateEx,NULL,addr g_pDD,GUID_(IID_IDirectDraw7),NULL
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("DirectDrawCreateEx FAILED"),offset szDXInfo,MB_OK
      return E_FAIL
   .endif

   return DD_OK
StartDD endp

StopDD proc
   .if DD_font != 0
       invoke  DeleteObject,DD_font
   .endif
   SAFE_RELEASE g_pSinusFont.dwSurface
   SAFE_RELEASE g_pDDSBack
   SAFE_RELEASE g_pDDSPrimary
   SAFE_RELEASE g_pDD
   ret
StopDD endp

Window_changed proc hwnd:DWORD
   invoke  GetClientRect,hwnd,addr rcPrimary
   invoke  ClientToScreen,hwnd,addr rcPrimary.left
   invoke  ClientToScreen,hwnd,addr rcPrimary.right

   m2m     dwScreenWidth,rcPrimary.right
   mov     eax,rcPrimary.left
   sub     dwScreenWidth,eax
   m2m     dwScreenHeight,rcPrimary.bottom
   mov     eax,rcPrimary.top
   sub     dwScreenHeight,eax

   ret
Window_changed endp




InitDD_Objects proc hwnd:DWORD 

   SAFE_RELEASE g_pDDSBack
   SAFE_RELEASE g_pDDSPrimary

   mov     rcBack.left,0
   mov     rcBack.top,0

       coinvoke g_pDD,IDirectDraw7,SetCooperativeLevel,hwnd,DDSCL_NORMAL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("SetCooperativeLevel FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       invoke  RtlZeroMemory,addr ddsd,sizeof DDSURFACEDESC2
       mov     ddsd.dwSize,sizeof DDSURFACEDESC2
       mov     ddsd.dwFlags,DDSD_CAPS
       mov     ddsd.ddsCaps.dwCaps,DDSCAPS_PRIMARYSURFACE

       coinvoke g_pDD,IDirectDraw7,CreateSurface,addr ddsd,addr g_pDDSPrimary, NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Create PrimarySurface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       invoke  RtlZeroMemory,addr ddsd,sizeof DDSURFACEDESC2
       mov     ddsd.dwSize,sizeof DDSURFACEDESC2
       mov     ddsd.dwFlags,DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT
       mov     ddsd.ddsCaps.dwCaps,DDSCAPS_OFFSCREENPLAIN

       mov     eax,dwWindow_Width
       mov     rcBack.right,eax
       mov     ddsd.dwWidth,eax

       mov     eax,dwWindow_Height
       mov     rcBack.bottom,eax
       mov     ddsd.dwHeight,eax

       coinvoke g_pDD,IDirectDraw7,CreateSurface,addr ddsd,addr g_pDDSBack, NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Create BackSurface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDD,IDirectDraw7,CreateClipper,0,addr g_pDDClipper,NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Create Clipper FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDDClipper,IDirectDrawClipper,SetHWnd,0,hwnd
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Clipper SetHWnd FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDDSPrimary,IDirectDrawSurface7,SetClipper,g_pDDClipper
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("SetClipper FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       SAFE_RELEASE g_pDDClipper


   m2m     dwScreenWidth,rcBack.right
   m2m     dwScreenHeight,rcBack.bottom

   m2m     rcPicture.left,rcBack.left  ; copie van de backbufferRect
   m2m     rcPicture.top,rcBack.top
   m2m     rcPicture.right,rcBack.right
   m2m     rcPicture.bottom,rcBack.bottom

   invoke  RtlZeroMemory,addr ddBack_bltfx,sizeof DDBLTFX
   mov     ddBack_bltfx.dwSize,sizeof DDBLTFX
   mov     ddBack_bltfx.dwFillColor,RGB(0,0,0)    ; vulkleur = zwart (0)

   coinvoke g_pDD,IDirectDraw7,GetDisplayMode,addr ddsd
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("GetDisplayMode FAILED"),offset szDXInfo,MB_OK
      return E_FAIL
   .endif

   mov     eax,ddsd.ddpfPixelFormat.dwRGBBitCount
   mov     dwRGBBitCount,eax
   mov     eax,ddsd.ddpfPixelFormat.dwRBitMask
   mov     dwRBitMask,eax
   mov     ecx,ddsd.ddpfPixelFormat.dwGBitMask
   mov     dwGBitMask,ecx
   add     eax,ecx
   mov     ecx,ddsd.ddpfPixelFormat.dwBBitMask
   mov     dwBBitMask,ecx
   add     eax,ecx
   .if eax == 32767
       mov dwRGBBitCount,15
   .endif

   invoke  Load_AllPictures

   return DD_OK
InitDD_Objects endp

RenderDD proc hwnd:DWORD
   coinvoke g_pDDSPrimary,IDirectDrawSurface7,IsLost
   .if eax == DDERR_SURFACELOST
       coinvoke g_pDD,IDirectDraw7,RestoreAllSurfaces
       .if eax != DD_OK
           invoke  InitDD_Objects,hwnd
       .elseif eax == DD_OK
           invoke  Load_AllPictures
       .endif
   .endif

       coinvoke g_pDD,IDirectDraw7,WaitForVerticalBlank,DDWAITVB_BLOCKBEGIN,NULL 
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("WaitForVerticalBlank FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDDSPrimary,IDirectDrawSurface7,Blt,addr rcPrimary,g_pDDSBack,NULL,DDBLT_WAIT,NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Blit to Primary Surface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

;  clear backbuffer
   coinvoke g_pDDSBack,IDirectDrawSurface7,Blt,NULL,NULL,NULL,DDBLT_COLORFILL or DDBLT_WAIT,addr ddBack_bltfx

 	invoke  Sinus_scroller
   return DD_OK
RenderDD endp


WndProc proc hwnd:DWORD,wMsg:DWORD,wParam:DWORD,lParam:DWORD
   .if wMsg == WM_DESTROY
       invoke   PostQuitMessage,NULL
       return   0

   .elseif wMsg == WM_SIZE   ; check if window size has changed
       .if wParam == SIZE_MINIMIZED
           mov      bProg_actief,FALSE
           mov      bMinimized,TRUE
           mov      bMaximized,FALSE
       .elseif wParam == SIZE_MAXIMIZED
           invoke   Window_changed,hwnd
           mov      bMinimized,FALSE
           mov      bMaximized,TRUE
       .elseif wParam == SIZE_RESTORED
           .if (bMaximized)
               invoke   Window_changed,hwnd
               mov      bMaximized,FALSE
           .elseif (bMinimized)
               mov      bProg_actief,TRUE
               mov      bMinimized,FALSE
           .endif
       .endif
       return   0

   .elseif wMsg == WM_EXITSIZEMOVE
           invoke   Window_changed,hwnd
       return   0

   .elseif wMsg == WM_PAINT
       invoke   ValidateRect,hwnd,NULL
       return   0

   .elseif wMsg == WM_KEYDOWN
       .if wParam == VK_ESCAPE
           invoke   PostQuitMessage,WM_QUIT
           return   0
        .endif
       return   0

   .else
       invoke   DefWindowProc,hwnd,wMsg,wParam,lParam
       ret
   .endif
WndProc endp



WinMain proc hinst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
 LOCAL wc:WNDCLASSEX
 LOCAL msg:MSG
 LOCAL hdc:HDC

   mov      wc.cbSize,sizeof WNDCLASSEX
   mov      wc.style,CS_HREDRAW or CS_VREDRAW or CS_OWNDC
   mov      eax,offset WndProc
   mov      WndProc_ptr,eax
   mov      wc.lpfnWndProc,eax
   mov      wc.cbClsExtra,NULL
   mov      wc.cbWndExtra,NULL
   mov      eax,hInst
   mov      wc.hInstance,eax
   invoke   GetStockObject,BLACK_BRUSH
   mov      wc.hbrBackground,eax
   mov      wc.lpszMenuName,NULL
   mov      wc.lpszClassName,offset szClassName
   invoke   LoadIcon,hInst,SMILEY_ICON
   mov      wc.hIcon,eax
   mov      wc.hIconSm,eax
   invoke   LoadCursor,NULL,IDC_ARROW
   mov      wc.hCursor,eax
   invoke   RegisterClassEx,addr wc

   invoke   SetRect,addr WindowRect,0,0,dwWindow_Width,dwWindow_Height
   invoke   AdjustWindowRectEx,addr WindowRect,WS_OVERLAPPEDWINDOW,FALSE,WS_EX_CLIENTEDGE

   invoke   GetDC,NULL
   mov      hdc,eax

   mov      eax,WindowRect.left
   sub      WindowRect.right, eax
   mov      eax,WindowRect.top
   sub      WindowRect.bottom, eax
   invoke   GetDeviceCaps,hdc,HORZRES
   mov      ScreenWidth,eax
   sub      eax,WindowRect.right
   shr      eax,1
   mov      WindowRect.left,eax
   invoke   GetDeviceCaps,hdc,VERTRES
   mov      ScreenHeight,eax
   sub      eax,WindowRect.bottom
   shr      eax,1
   mov      WindowRect.top,eax
   invoke   GetDeviceCaps,hdc,BITSPIXEL
   mov      ScreenBits,eax
   invoke   GetDeviceCaps,hdc,VREFRESH
   mov      ScreenRefreshRate,eax

   invoke   DeleteDC,hdc

   invoke   GetDesktopWindow
   invoke   CreateWindowEx,WS_EX_CLIENTEDGE,addr szClassName,addr szAppName,WS_OVERLAPPEDWINDOW, \
                           WindowRect.left,WindowRect.top,WindowRect.right,WindowRect.bottom,eax,NULL,hInst,NULL
   mov      hWnd,eax


   invoke   Window_changed,eax


   invoke   UpdateWindow,hWnd
   invoke   ShowWindow,hWnd,SW_SHOWNORMAL

   invoke   StartDD
   if_FAILED
      jmp   EndDD
   .endif

   invoke   InitDD_Objects,hWnd 
   if_FAILED
      SAFE_RELEASE g_pDD
      jmp   EndDD
   .endif


   invoke   RenderDD,hWnd

   invoke   RtlZeroMemory,addr msg,sizeof msg

   .while TRUE
      invoke PeekMessage,addr msg,NULL,0,0,PM_REMOVE
      .if eax != 0
          .if msg.message == WM_QUIT
              invoke PostQuitMessage,msg.wParam
              .break
          .else
              invoke TranslateMessage,addr msg
              invoke DispatchMessage,addr msg
          .endif 
      .else
          invoke   RenderDD,hWnd
          invoke	Sleep,10                   
      .endif
   .endw

EndDD:

   invoke   StopDD 
   invoke   CoUninitialize
   invoke   UnregisterClass,addr szClassName,wc.hInstance

   mov      eax,msg.wParam
   ret
WinMain endp


start:
   invoke   CoInitialize,NULL

   invoke   GetModuleHandle,NULL
   mov      hInst,eax

   invoke   GetProcessHeap
   mov      Heap,eax

   invoke   WinMain,hInst,NULL,NULL,SW_SHOWDEFAULT
   invoke   ExitProcess,eax
end start
